#include <tiny2313.h>
#include <delay.h>

#define SPI_CE_PORT   PORTD
#define SPI_CLK_PORT  PORTA
#define SPI_DATA_PORT PORTA
#define CE_PIN   2
#define CLK_PIN  0
#define DATA_PIN 1

unsigned char a;
unsigned int DIVISOR;

#define Lcd_Put(Seg1, Seg2, Seg3, Seg4) DisplayBuffer[0] = Seg1, DisplayBuffer[1] = Seg2, DisplayBuffer[2] = Seg3, DisplayBuffer[3] = Seg4 
unsigned char DisplayBuffer[4];
unsigned char i;
unsigned char Comma;

flash unsigned char Character[12] =
{
0b00111111, //'0'  #0
0b00000110, //'1'  #1
0b01011011, //'2'  #2
0b01001111, //'3'  #3
0b01100110, //'4'  #4
0b01101101, //'5'  #5
0b01111101, //'6'  #6
0b00000111, //'7'  #7
0b01111111, //'8'  #8
0b01101111, //'9'  #9
0b00000000, // Off #10
};

interrupt[TIM0_OVF] void timer0_ovf_isr(void)
{
PORTD &= 0b10000111;
PORTB = (~(Character[DisplayBuffer[i-3]]));
if(i == Comma) PORTB &= 0b01111111;
PORTD |= (1<<i);
if(i++ == 6) i = 3;
}

void Send8Bit(unsigned char Data)
{
for(a = 0; a < 8; a++)
	{
  SPI_CLK_PORT.CLK_PIN = 0;
	SPI_DATA_PORT.DATA_PIN = Data&0x01;
	delay_us(20);
	Data >>=1;
	SPI_CLK_PORT.CLK_PIN = 1;
	delay_us(20);
  }
}

void Lm7001DataTransmitt(void)
{
SPI_CE_PORT |= (1<<CE_PIN);

Send8Bit(DIVISOR & 0xFF);
Send8Bit((DIVISOR >> 8) & 0xFF);

Send8Bit(0b10000000);

PORTA = 0;
PORTD.CE_PIN = 0; 
}

void Data_Decoding(void)
{
if(DIVISOR < 1000)
  {
  Lcd_Put(DIVISOR/100, ((DIVISOR/10)%10), DIVISOR%10, 10);
  Comma = 4;
  }
else
  {
  Lcd_Put(DIVISOR/1000, ((DIVISOR/100)%10), ((DIVISOR/10)%10), DIVISOR%10);
  Comma = 5;
  }
}

void Control(void)
{ 
if(!PIND.0)
  {
  DIVISOR = DIVISOR + 1;
  if(DIVISOR > 1080) DIVISOR = 875;
  Data_Decoding();
  Lm7001DataTransmitt();
  delay_ms(200);
  return;
  }
  
if(!PIND.1)
  {
  DIVISOR = DIVISOR - 1;
  if(DIVISOR < 875) DIVISOR = 1080;
  Data_Decoding();
  Lm7001DataTransmitt();
  delay_ms(200);
  return;
  }
}

void main(void)
{
DDRB  = 255;
DDRD  = 0b11111100;
PORTD = 0b00000011;
DDRA  = 3;
DIVISOR = 875;
i = 3;
Comma = 7;
Lcd_Put(10, 10, 10, 10);

while(EECR & (1<<1));
EEAR = 0;
EECR |= (1<<0);
DIVISOR = EEDR;
if (DIVISOR > 206) DIVISOR = 1;
if (DIVISOR < 1) DIVISOR = 1;
DIVISOR = DIVISOR + 874;

Lm7001DataTransmitt();
Data_Decoding();

TCCR0 = 0b00000011;
TIMSK = 0b00000010;
#asm("sei")

while(1)
  {
  Control();
  }    
}